# Clustering with R

iris = read.csv('iris.csv', header=TRUE, sep=',')

iris.norm <- iris
for (i in c(1:length(iris.norm))){
	if (!is.factor(iris.norm[,i])){
		attr.mean <- mean(iris.norm[,i])
		attr.sd <- sd(iris.norm[,i])
		iris.norm[,i] <- (iris.norm[,i]-attr.mean)/attr.sd
	}
}
iris.norm$sepal.length

iris.num <- iris.norm[1:4]

# hierarchical clustering methods "ward.D", "ward.D2", "single", "complete", "average"

d <- dist(iris.num, method='euclidean') # distance matrix
iris.cl <- hclust(d, method='ward.D') 
plot(iris.cl) # display dendogram
groups <- cutree(fit, k=3) # cut tree into 3 clusters

# draw dendogram with red borders around the 5 clusters 
rect.hclust(fit, k=3, border='red')


#library(gplots)
#rowv <- as.dendrogram(hclust(dist(iris.num), method='ward.D'))
#colv <- as.dendrogram(hclust(dist(t(iris.num)), method='ward.D'))
#heatmap.2(as.matrix(iris.num), Rowv=rowv,Colv=colv, trace='none')


# centroid based clsutering k-means
iris.km <- kmeans(iris.num, centers=3, iter.max=10, nstrart=10)
iris.km

# clusters
iris.km$cluster

# centers
iris.km$centers

clusplot(iris.num, iris.km$cluster, color=TRUE, shade=TRUE, labels=2, lines=0)
plotcluster(iris.num, iris.km$cluster)

# fuzzy clustering
library(cluster)
iris.fcm <- fanny(iris.num,3)
iris.fcm


# density based DBSCAN
library(fpc)
iris.dbscan <- dbscan(iris.num[,1:4],1.0,showplot=T)
iris.dbscan$cluster

# validating cluster
cluster.stats(d, iris.km$cluster, iris.dbscan$cluster)

# gaussian mixture model
library(mclust)
iris.em <- mclustBIC(iris.num[,1:4])
iris.mod <- mclustModel(iris.num[,1:4],iris.em)
summary(iris.mod)